/* FreeMem.PRG: Return amount of free memory/resources
   Call with "System," "GDI," or "User".  First character is significant.
*/
Function FreeMem
   parameter cRType
   if type("cRType") # 'C'
      return -1
   endif
   nRType = at(upper(left(cRType,1)),'SGU') - 1
   if nRType < 0
      return -1
   endif 
   if type('GetFreeSystemResources') # 'FP'
      extern cint GetFreeSystemResources(cint) rsrc32.dll ;
             from '_MyGetFreeSystemResources32@4'
   endif
   
return GetFreeSystemResources(nRType)

