***************************************************************************
*  Copyright (C) 1998 Marcello Perathoner. All rights reserved.           *
*  email: JLSeagull@csi.com                                               *
*  http://ourworld.compuserve.com/Homepages/JLSeagull/vdb/index.html      *
***************************************************************************

#define NDEBUG

   set procedure to program (1) additive
   InitHLStruct ()
RETURN

************************************************************************
* todo:
* bitfields
* unions
************************************************************************

#include "hlwinapi.cch"
#define int CINT

PROCEDURE InitHLStruct
   DO ("hlwinapi.cc")

   _app.HLStructHLMems = 0
   _app.HLStructHLMemMallocs = 0
   _app.HLStructHLMemMallocedBytes = 0
   IF type ("_WinAPIMoveMemory_ptr_ptr") == "FP"
      RETURN
   ENDIF

#ifdef __vdb__
   extern VOID _WinAPIMoveMemory_ptr_ptr        (PVOID, PCVOID, ULONG)        kernel32  from "RtlMoveMemory"
   extern VOID _WinAPIMoveMemory_ptr_lptr       (PVOID, ULONG,  ULONG)        kernel32  from "RtlMoveMemory"
   extern VOID _WinAPIMoveMemory_lptr_ptr       (ULONG, PCVOID, ULONG)        kernel32  from "RtlMoveMemory"
   extern VOID _WinAPIZeroMemory                (ULONG, ULONG)                kernel32  from "RtlZeroMemory"

   * some deliberately wrong declarations for data type conversion
   extern CVOID _WinAPIMoveMemory_lptr_int32    (CLONG, CPTR CLONG, CLONG)    kernel32 from "RtlMoveMemory"
   extern CVOID _WinAPIMoveMemory_lptr_float64  (CPTR, CPTR CDOUBLE, CLONG)   kernel32 from "RtlMoveMemory"

   extern CVOID _WinAPIMoveMemory_int32_lptr    (CPTR CLONG, CLONG, CLONG)    kernel32 from "RtlMoveMemory"
   extern CVOID _WinAPIMoveMemory_float64_lptr  (CPTR CDOUBLE, CPTR, CLONG)   kernel32 from "RtlMoveMemory"

   extern CINT  _WinAPIlstrlenW                 (CLONG)                       kernel32 from "lstrlenW"
   extern CINT  _WinAPIlstrlenA                 (CLONG)                       kernel32 from "lstrlenA"

   extern HANDLE  WinAPICreateFile     (LPCTSTR, DWORD, DWORD, LONG, DWORD, DWORD, HANDLE) kernel32 from "CreateFile" U
   extern BOOL    WinAPICloseHandle    (HANDLE)                                  kernel32 from "CloseHandle"
   extern BOOL    WinAPIReadFile       (HANDLE, LONG, DWORD, CPTR DWORD, CLONG)  kernel32 from "ReadFile"
   extern BOOL    WinAPIWriteFile      (HANDLE, LONG, DWORD, CPTR DWORD, CLONG)  kernel32 from "WriteFile"
   extern DWORD   WinAPISetFilePointer (HANDLE, LONG, CPTR LONG, DWORD)          kernel32 from "SetFilePointer"

   extern CINT    _WinAPIMultiByteToWideChar (UINT, DWORD, LONG, int, LONG, int)                    kernel32 from "MultiByteToWideChar"
   extern CINT    _WinAPIWideCharToMultiByte (UINT, DWORD, LONG, int, LONG, int, LPCSTR, CPTR BOOL) kernel32 from "WideCharToMultiByte"

#else
   extern VOID _WinAPIMoveMemory_ptr_ptr        (CPTR, CPTR,  CLONG)          kernel  from "hmemcpy"
   extern VOID _WinAPIMoveMemory_lptr_ptr       (CLONG, CPTR, CLONG)          kernel  from "hmemcpy"
   extern VOID _WinAPIMoveMemory_ptr_lptr       (CPTR, CLONG, CLONG)          kernel  from "hmemcpy"

   * some deliberately wrong declarations for data type conversion
   extern CVOID _WinAPIMoveMemory_lptr_int32    (CLONG, CVAR, CLONG)          kernel from "hmemcpy"
   extern CVOID _WinAPIMoveMemory_lptr_float80  (CLONG, CVAR, CLONG)          kernel from "hmemcpy"

   extern CVOID _WinAPIMoveMemory_int32_lptr    (CVAR, CLONG, CLONG)          kernel from "hmemcpy"
   extern CVOID _WinAPIMoveMemory_float80_lptr  (CVAR, CLONG, CLONG)          kernel from "hmemcpy"

   extern CINT  _WinAPIlstrlenW                 (CLONG)                       kernel from "lstrlen"
   extern CINT  _WinAPIlstrlenA                 (CLONG)                       kernel from "lstrlen"

   #define HFILE  int
   extern HFILE   WinAPI_lopen                  (LPCSTR, int)                 kernel from "_lopen"
   extern HFILE   WinAPI_lcreat                 (LPCSTR, int)                 kernel from "_lcreat"
   extern HFILE   WinAPI_lclose                 (HFILE)                       kernel from "_lclose"
   extern LONG    WinAPI_hread                  (HFILE, LONG, LONG)           kernel from "_hread"
   extern LONG    WinAPI_hwrite                 (HFILE, LONG, LONG)           kernel from "_hwrite"
   extern LONG    WinAPI_llseek                 (HFILE, LONG, int)            kernel from "_llseek"

#endif

   extern CVOID _WinAPISetRect_cptr           (CPTR, CPTR, CINT, CINT, CINT)  user   from "SetRect"
RETURN

#undef int

#ifdef __vdb__
   #define _THROW(a) throw new HLStructException (a)

   CLASS HLStructException (cWhy) OF Exception
      this.message = cWhy

      PROCEDURE Why
      RETURN message
   ENDCLASS
#else
   #define _THROW(a) MsgBox (a, "throw", MB_OK) ; cancel
#endif

PROCEDURE IsObj ; PARAMETERS o
RETURN type ("o") == "O"

PROCEDURE IsStr ; PARAMETERS s
RETURN type ("s") == "C"

PROCEDURE IsNum ; PARAMETERS n
RETURN type ("n") == "N"

************************************************************************
* Field
************************************************************************

#ifndef __vdb__
PROCEDURE HLPlugIn (oStruct, oContainer, cName)
   * made this global to overcome 5.6 preprocessor limitations
   oStruct.Plugin (oContainer, cName)
RETURN
#endif

CLASS HLSFieldType (oContainer)
   PROTECT GetValue, SetValue
   * PROTECT parent
   * PROTECT NextField
   * defines the field interface (and the decorator interface)
   this.parent    = iif (IsObj (oContainer), oContainer, NULL)
   this.ClassName = "HLSFieldType"
   this.Name      = "No Name"
   this.NextField = NULL

   PROCEDURE GetContainer
      * return container object (HLStruct)
   RETURN this.parent.GetContainer ()

   PROCEDURE GetValue
      * value is stored in a property of the container
      * this allows for access with native language:
      *   ? oStruct.value
      *   oStruct.value = 1
      * instead of contortions like:
      *   ? oStruct.GetValue ("value")
      *   oStruct.SetValue ("value", 1)
      * on first call turn GetValue into a CodeBlock for faster access
      this.oContainer = this.GetContainer ()
      PRIVATE value ; value = NULL
      PRIVATE macro
      IF IsStr (this.name)
         macro = "this.GetValue = {; return this.oContainer." + this.name + " }"
      ELSEIF IsNum (this.name)
         macro = "this.GetValue = {; return this.oContainer [" + ltrim (str (this.name)) + "] }"
      ELSE
         _THROW("HLSFieldType::GetValue () : Field name not string nor number")
      ENDIF
      &macro.
   RETURN this.GetValue ()

   PROCEDURE SetValue ; PARAMETERS value
      * on first call turn SetValue into a CodeBlock for faster access
      this.oContainer = this.GetContainer ()
      PRIVATE macro
      IF IsStr (this.name)
         macro = "this.SetValue = {|value|; this.oContainer." + this.name + " = value }"
      ELSEIF IsNum (this.name)
         macro = "this.SetValue = {|value|; this.oContainer [" + ltrim (str (this.name)) + "] = value }"
      ELSE
         _THROW("HLSFieldType::SetValue () : Field name not string nor number")
      ENDIF
      &macro.
      this.SetValue (value)
   RETURN

   PROCEDURE ClearValue
      this.SetValue (NULL)
   RETURN

   PROCEDURE PlugIn (oContainer, cName)
      * insert an already constructed HLStruct
      * into a container
      this.parent = iif (IsObj (oContainer), oContainer, NULL)
      IF IsStr (cName) .or. IsNum (cName)
         this.Name = cName
      ENDIF
      IF .not. empty (this.parent)
         this.parent.Append ((this), cName)
      ENDIF
   RETURN

   PROCEDURE Put_
      _THROW("HLSFieldType::Put_ should have been overridden")
   RETURN

   PROCEDURE Get_
      _THROW("HLSFieldType::Get_ should have been overridden")
   RETURN

   PROCEDURE GetSize
   RETURN 0

   PROCEDURE TryAnsiDecorate
      * you can AnsiDecorate a String or ByteArray but not a scalar or struct
      _THROW("You cannot AnsiDecorate me")
   RETURN

   PROCEDURE IsNull
   RETURN false

   PROCEDURE Release
   RETURN

#ifndef NDEBUG
   PROCEDURE PrintDebugInfo_ (nOffs, nIndent)
      ? this.name at nIndent, int (nOffs) at 30, int (this.GetSize ()) at 40
   RETURN
#endif
ENDCLASS

CLASS HLSField (oContainer, cName) OF HLSFieldType (oContainer)
   * a real field (not a decorator)
   this.ClassName = "HLSField"
   this.PlugIn (oContainer, cName)

ENDCLASS

************************************************************************
* HLStruct
************************************************************************

CLASS HLStruct (oContainer, cName) OF HLSField (oContainer, cName)
   PROTECT LastField, Mem, FldCount
   * PROTECT FirstField
   * a container class for fields
   * and itself a field (for nested structs)
   this.ClassName  = "HLStruct"
   this.fldcount   = 0
   this.FirstField = NULL
   this.LastField  = NULL
   this.mem        = new HLMem ()

   PROCEDURE Release
      PRIVATE f ; f = this.FirstField
      DO WHILE .not. empty (f)
         f.Release ()
         f = f.NextField
      ENDDO
      this.mem.Release ()
   RETURN

   PROCEDURE GetContainer
   RETURN this

   PROCEDURE GetMem
   RETURN this.mem

   PROCEDURE GetFieldCount
   RETURN this.fldcount

   PROCEDURE PlugIn (oContainer, cName)
      super::Plugin (oContainer, cName)
      IF .not. empty (this.parent)
         * make a reference to HLStruct
         * HLStruct has no "value", so SetValue will not be called
         LOCAL oContainer ; oContainer = super::GetContainer ()
         oContainer.MakeRef ((this), cName)
      ENDIF
   RETURN

   PROCEDURE GetSize
      PRIVATE f ; f = this.FirstField
      LOCAL size ; size = 0
      DO WHILE .not. empty (f)
         size = size + f.GetSize ()
         f = f.NextField
      ENDDO
   RETURN size

   PROCEDURE GetValue
   RETURN NULL

   PROCEDURE SetValue (newVal)
   RETURN

   PROCEDURE ClearValue
   RETURN

   PROCEDURE MakeRef ; PARAMETERS oField, cName
      PRIVATE macro
      IF IsStr (cName)
         macro = "this." + cName + " = oField"
      ELSEIF IsNum (cName)
         macro = "this [cName] = oField"
      ELSE
         _THROW("HLStruct::MakeRef () : Field name not string not number")
      ENDIF
      &macro.
   RETURN

   PROCEDURE Append (oField, cName)
      IF empty (this.LastField)
         this.FirstField = oField
      ELSE
         this.LastField.NextField = oField
      ENDIF
      this.LastField = oField
      this.fldcount = this.fldcount + 1
   RETURN this

   PROCEDURE Put
      LOCAL nSize ; nSize = this.GetSize ()
      IF this.mem.size < nSize
         this.mem.malloc (nSize)
      ENDIF
      this.mem.clear ()

      this.Put_ (this.mem, 0)
   RETURN this.mem.GetAddr ()

   PROCEDURE Get
      this.Get_ (this.mem, 0)
   RETURN

   PROCEDURE Put_ (oMem, nOffs)
      LOCAL offs ; offs = nOffs
      PRIVATE f ; f = this.FirstField
      DO WHILE .not. empty (f)
         f.Put_ ((oMem), (offs))
         offs = offs + f.GetSize ()
         f = f.NextField
      ENDDO
   RETURN

   PROCEDURE Get_ (oMem, nOffs)
      LOCAL offs ; offs = nOffs
      PRIVATE f ; f = this.FirstField
      DO WHILE .not. empty (f)
         f.Get_ ((oMem), (offs))
         offs = offs + f.GetSize ()
         f = f.NextField
      ENDDO
   RETURN

   PROCEDURE ToString
   RETURN this.mem.ToString ()

   PROCEDURE FromString (s)
      this.mem.FromString (s)
   RETURN

   PROCEDURE FromMem (oMem)
      this.mem.FromMem (oMem, 0, oMem.size)
   RETURN

   PROCEDURE ToStatus
      LOCAL status ; status = "{"
      PRIVATE f ; f = this.FirstField
      DO WHILE .not. empty (f)
         status = status + f.ToStatus ()
         f = f.NextField
      ENDDO
   RETURN status + "}"

   PROCEDURE FromStatus (status)
      IF left (status, 1) <> "{"
         _THROW("HLStruct: { Bad FromStatus data")
      ENDIF
      status = substr (status, 2)
      PRIVATE f ; f = this.FirstField
      DO WHILE .not. empty (f)
         f.FromStatus (status)
         f = f.NextField
      ENDDO
      IF left (status, 1) <> "}"
         _THROW("HLStruct: } Bad FromStatus data")
      ENDIF
      status = substr (status, 2)
   RETURN

   PROCEDURE ToINI (cPath, cSection, cEntry)
      WinAPIWritePrivateProfileString (cSection, cEntry, this.ToStatus (), cPath)
   RETURN

   PROCEDURE FromINI (cPath, cSection, cEntry)
      LOCAL cBuffer ; cBuffer = hlcalloc (8192)
      LOCAL nLen ; nLen = WinAPIGetPrivateProfileString (cSection, cEntry, ;
         "", cBuffer, len (cBuffer), cPath)
      IF nLen > 0
         this.FromStatus (left (cBuffer, nLen))
      ENDIF
   RETURN nLen > 0

   PROCEDURE malloc (nSize)
      this.mem.malloc (nSize)
   RETURN

#ifndef NDEBUG
   PROCEDURE PrintDebugInfo
      this.PrintDebugInfo_ (0, 0)
      this.mem.PrintHex (0)
   RETURN

   PROCEDURE PrintDebugInfo_ (nOffs, nIndent)
      LOCAL offs ; offs = nOffs
      super::PrintDebugInfo_ (offs, nIndent)
      PRIVATE f ; f = this.FirstField
      DO WHILE .not. empty (f)
         f.PrintDebugInfo_ (offs, nIndent + 2)
         offs = offs + f.GetSize ()
         f = f.NextField
      ENDDO
   RETURN
#endif
ENDCLASS

CLASS HLSArray (oContainer, cName) OF HLStruct (oContainer, cName)
   this.classname = "HLSArray"
   * arrays must be assembled manually like this
   *
   * CLASS MyArray (nElements) OF HLSArray
   *    LOCAL i
   *    FOR i = 0 TO nElements
   *       HLS_INT(i)   && use appropriate HLS-macro here
   *    NEXT
   * ENDCLASS
   *
   * use only one element type in array or build an array of inlined
   * HLStructs with this inside the FOR loop:
   * HLS_INLINEDSTRUCT(i, new HLS_POINT ())  && HLS_POINT is just an example
   *
   * this class is underimplemented but we cannot do much better than this
   * because preprocessor defines don't work in macro substitution
   * and there is no object copy operator in VdB (big design flaw !!!)
   *
ENDCLASS

************************************************************************
* Decorators (Wrappers)
************************************************************************

CLASS HLSDecoratorType (oParent) OF HLSFieldType (oParent)
   * transparent decorator
   * just pass on (most) calls from Container to Field and Field to Container
   this.ClassName = "HLSDecoratorType"

   PROCEDURE Append (oField, cName)
      * insert _us_ into the container field and keep a pointer to the field
      * because we have the type of a field (we inherit from HLSFieldType)
      * the container wont notice that we crept in
      this.oDecorated = oField
   RETURN this.parent.Append ((this), cName)

   * pass these transparently from container to field

   PROCEDURE Put_ (oMem, nOffs)
   RETURN this.oDecorated.Put_ (oMem, nOffs)

   PROCEDURE Get_ (oMem, nOffs)
   RETURN this.oDecorated.Get_ (oMem, nOffs)

   PROCEDURE ClearValue
      this.oDecorated.ClearValue ()
   RETURN

   PROCEDURE GetSize
   RETURN this.oDecorated.GetSize ()

   PROCEDURE TryAnsiDecorate
      this.oDecorated.TryAnsiDecorate ()
   RETURN

   PROCEDURE IsNull
   RETURN this.oDecorated.IsNull ()

   PROCEDURE Release
      this.oDecorated.Release ()
   RETURN

   PROCEDURE ToStatus
   RETURN this.oDecorated.ToStatus ()

   PROCEDURE FromStatus (status)
   RETURN this.oDecorated.FromStatus (status)

ENDCLASS

CLASS HLSInlineDecorator (oDecorated) OF HLSDecoratorType (oDecorated)
   * transparent (inlining is the default field behaviour)
   this.ClassName = "HLSInlineDecorator"

#ifndef NDEBUG
   PROCEDURE PrintDebugInfo_ (nOffs, nIndent)
      super::PrintDebugInfo_ (nOffs, nIndent)
      this.oDecorated.PrintDebugInfo_ (nOffs, nIndent + 2)
      this.mem.PrintHex (nIndent)
   RETURN
#endif
ENDCLASS

CLASS HLSConstDecorator (oDecorated) OF HLSDecoratorType (oDecorated)
   * for items that won't Get modified by window
   this.ClassName = "HLSConstDecorator"

   PROCEDURE Get_ (oMem, nOffs)
      * eat this call
   RETURN

#ifndef NDEBUG
   PROCEDURE PrintDebugInfo_ (nOffs, nIndent)
      super::PrintDebugInfo_ (nOffs, nIndent)
      this.oDecorated.PrintDebugInfo_ (nOffs, nIndent + 2)
   RETURN
#endif
ENDCLASS

CLASS HLSLPDecorator (oDecorated) OF HLSDecoratorType (oDecorated)
   * insert a pointer to the field (instead of inlining)
   this.ClassName = "HLSLPDecorator"
   this.mem = new HLMem ()

   PROCEDURE GetSize
   RETURN 4

   PROCEDURE Put_ (oMem, nOffs)
      IF .not. this.IsNull ()
         this.mem.malloc (this.oDecorated.GetSize ())
         this.oDecorated.Put_ (this.mem, 0)  && puts into our mem
         * Put addr of our mem
         oMem.PutUnsigned (nOffs, this.mem.mem, this.GetSize ())
      ENDIF
   RETURN

   PROCEDURE Get_ (oMem, nOffs)
      LOCAL addr ; addr = oMem.GetUnsigned (nOffs, this.GetSize ())
      IF addr <> 0
         IF addr == this.mem.mem
            this.oDecorated.Get_ (this.mem, 0)  && gets from our mem
         ELSE
            * pointer changed
            * we are in some trouble here because we cannot know what
            * size the data pointed to is
            * we just assume the decorated object knows something
            * about this data
            * ? "Pointer changed : " + itoh (this.mem.mem) + "->" + itoh (addr)
            this.mem.free ()
            this.mem.FromPtr (addr, 0)
            this.oDecorated.Get_ (this.mem, 0)  && gets from our mem
         ENDIF
      ELSE
         this.oDecorated.ClearValue ()
      ENDIF
      this.mem.free ()
   RETURN

   PROCEDURE Release
      this.mem.Release ()
      super::release ()
   RETURN

#ifndef NDEBUG
   PROCEDURE PrintDebugInfo_ (nOffs, nIndent)
      super::PrintDebugInfo_ (nOffs, nIndent)
      this.oDecorated.PrintDebugInfo_ (0, nIndent + 2)
      this.mem.PrintHex (nIndent)
   RETURN
#endif
ENDCLASS

CLASS HLSHGlobDecorator (oDecorated) OF HLSDecoratorType (oDecorated)
   * insert a HGLOBAL with the fields contents (instead of inlining)
   this.ClassName = "HLSHGlobDecorator"
   this.mem = new HLMem ()
   this.hGlobUnowned = false

   PROCEDURE GetSize
   RETURN SIZEOF_HANDLE

   * a HGLOBAL of another struct
   PROCEDURE Put_ (oMem, nOffs)
      IF .not. this.IsNull ()
         this.mem.malloc (this.oDecorated.GetSize ())
         this.oDecorated.Put_ (this.mem, 0)
         * Put HGLOBAL of our mem
         oMem.PutUnsigned (nOffs, this.mem.hGlob, this.GetSize ())
         this.mem.UnownHGlob ()  && release ownership but dont free hGlob
         this.hGlobUnowned = true
      ENDIF
   RETURN

   PROCEDURE Get_ (oMem, nOffs)
      * reload data from hGlob
      LOCAL hGlob ; hGlob = oMem.GetUnsigned (nOffs, this.GetSize ())
      IF hGlob <> 0
         this.mem.FromHGlob (hGlob)
         this.oDecorated.Get_ (this.mem, 0)
      ENDIF
      this.hGlobUnowned = false
   RETURN

#ifndef NDEBUG
   PROCEDURE PrintDebugInfo_ (nOffs, nIndent)
      super::PrintDebugInfo_ (nOffs, nIndent)
      this.oDecorated.PrintDebugInfo_ (0, nIndent + 2)
      this.mem.PrintHex (nIndent)
   RETURN
#endif
   PROCEDURE Release
      IF this.hGlobUnowned
         * somebody called Put but not Get
         * this will serve him/her right
         _THROW("You _MUST_ call Get () after you call Put () when using HGLOBALS !!!")
      ENDIF
      this.mem.Release ()
      super::Release ()
   RETURN
ENDCLASS

CLASS HLSAnsiDecorator (oDecorated) OF HLSDecoratorType (oDecorated)
   * translate Field contents from Unicode to Ansi
   this.ClassName = "HLSAnsiDecorator"
#ifdef __vdb__
   *
   * AnsiDecorator is useless in 16-bit
   *
   * Code Page Default Values.
   *
   #define CP_ACP               0                     && default to ANSI code page
   #define CP_OEMCP             1                     && default to OEM  code page
   #define CP_MACCP             2                     && default to MAC  code page
   #define CP_UTF7              65000                 && UTF-7 translation
   #define CP_UTF8              65001                 && UTF-8 translation
   *
   *  MBCS and Unicode Translation Flags.
   *
   #define MB_PRECOMPOSED       htoi ("00000001")     && use precomposed chars
   #define MB_COMPOSITE         htoi ("00000002")     && use composite chars
   #define MB_USEGLYPHCHARS     htoi ("00000004")     && use glyph chars, not ctrl chars
   #define MB_ERR_INVALID_CHARS htoi ("00000008")     && error for invalid chars
   #define WC_DEFAULTCHECK      htoi ("00000100")     && check for default char
   #define WC_COMPOSITECHECK    htoi ("00000200")     && convert composite to precomposed
   #define WC_DISCARDNS         htoi ("00000010")     && discard non-spacing chars
   #define WC_SEPCHARS          htoi ("00000020")     && generate separate chars
   #define WC_DEFAULTCHAR       htoi ("00000040")     && replace w/ default char

   this.mem = new HLMem ()

   PROCEDURE GetSize
   RETURN this.oDecorated.GetSize () / SIZEOF_VDBCHAR

   PROCEDURE Put_ (oMem, nOffs)
      this.oDecorated.TryAnsiDecorate ()  && throws HLStructException
      IF .not. this.IsNull ()
         this.mem.malloc (this.oDecorated.GetSize ())
         this.oDecorated.Put_ (this.mem, 0)     && puts into our mem
         * we need an unicode->ansi translation that doesn't stop on L'\0'
         * eg. struct DEVNAMES uses a multi-'\0'-string
         _WinAPIWideCharToMultiByte (CP_ACP, WC_COMPOSITECHECK + WC_DISCARDNS, ;
                  this.mem.GetAddr (), this.GetSize (), ;
                  oMem.GetAddr () + nOffs, this.GetSize (), NULL, NULL)
      ENDIF
   RETURN

   PROCEDURE Get_ (oMem, nOffs)
      LOCAL len
      * FIXME
      * there should be a way for AnsiDecorator to ask the decorated element
      * the type of the data (string0, string00, fixed len)
      * here we eventually end up translating many more bytes than necessary
      IF oMem.size > 0
         len = oMem.size - nOffs
      ELSE
         len = _WinAPIlstrlenA (oMem.mem + nOffs)
      ENDIF
      this.mem.malloc ((len + 1) * SIZEOF_VDBCHAR)

      * we need an unicode->ansi translation that doesn't stop on L'\0'
      * eg. struct DEVNAMES uses a multi-'\0'-string
      _WinAPIMultiByteToWideChar (CP_ACP, MB_PRECOMPOSED, ;
                  oMem.GetAddr () + nOffs, len, ;
                  this.mem.GetAddr (), len)

      this.oDecorated.Get_ (this.mem, 0)
   RETURN

   PROCEDURE TryAnsiDecorate
      _THROW("You cannot AnsiDecorate an AnsiDecorator")
   RETURN

#ifndef NDEBUG
   PROCEDURE PrintDebugInfo_ (nOffs, nIndent)
      super::PrintDebugInfo_ (nOffs, nIndent)
      this.oDecorated.PrintDebugInfo_ (nOffs, nIndent + 2)
   RETURN
#endif

   PROCEDURE Release
      this.mem.Release ()
      super::Release ()
   RETURN
#endif
ENDCLASS

************************************************************************
* Concrete Fields
************************************************************************

CLASS HLSByteArray (oContainer, cName, nSize) OF HLSField (oContainer, cName)
   PROTECT size
   * a fixed size byte array that makes no assumptions about its contents
   * nSize in bytes
   this.ClassName = "HLSByteArray"
   this.size = nSize
   this.SetValue (NULL)

   PROCEDURE GetSize
   RETURN this.size

   PROCEDURE Put_ (oMem, nOffs)
      IF .not. this.IsNull ()
         oMem.PutBytes (nOffs, this.GetValue (), this.GetSize ())
      ENDIF
   RETURN

   PROCEDURE Get_ (oMem, nOffs)
      this.SetValue (oMem.GetBytes (nOffs, this.GetSize ()))
   RETURN

   PROCEDURE TryAnsiDecorate
      * yes you can AnsiDecorate me
   RETURN

   PROCEDURE IsNull
   RETURN this.GetValue () == NULL

   PROCEDURE ToStatus
      LOCAL i, len, hex
      len = len (this.GetValue ()) * SIZEOF_VDBCHAR - 1
      hex = ""
      FOR i = 0 to len
         hex = hex + itoh (GET_BYTE(this.GetValue (), i), 2)
      NEXT
   RETURN ltrim (str (len (this.GetValue ()))) + ">" + hex + ";"

   PROCEDURE FromStatus (status)
      LOCAL i, len, s
      len = val (status)
      status = substr (status, at (">", status) + 1)
      IF substr (status, len + 1, 1) <> ";"
         _THROW("HLSByteArray Bad FromStatus data")
      ENDIF
      this.SetValue (MEM_ALLOC(len))
      FOR i = 0 to len - 1
         SET_BYTE(this.GetValue (), i, htoi (substr (status, i * 2 + 1, 2)))
      NEXT
      this.SetValue (s)
      status = substr (status, len + 2)
   RETURN
ENDCLASS

CLASS HLSFixedString (oContainer, cName, nSize) OF HLSByteArray (oContainer, cName, nSize * SIZEOF_VDBCHAR)
   * assumes contents is "string" data, unicode or ansi, terminated by \0
   * a fixed length string that will
   * read until \0 and
   * write and fill up with \0
   this.ClassName = "HLSFixedString"

   PROCEDURE Get_ (oMem, nOffs)
      LOCAL len ; len = _WinAPIlstrlenW (oMem.mem + nOffs)
      * ? "HLSFixedString strlen = ", len
      LOCAL s ; s = oMem.GetBytes (nOffs, (len + 1) * SIZEOF_VDBCHAR)
      * cut on \0
      LOCAL i ; i = at (chr (0), s)
      IF i <> -1
         this.SetValue (left (s, i - 1))
      ELSE
         this.SetValue (s)
      ENDIF
   RETURN

   PROCEDURE ToStatus
   RETURN ltrim (str (len (this.GetValue ()))) + ">" + this.GetValue () + ";"

   PROCEDURE FromStatus (status)
      LOCAL slen
      slen = val (left (status, at (">", status)))
      status = substr (status, at (">", status) + 1)
      IF substr (status, slen + 1, 1) <> ";"
         _THROW("HLSFixedString: Bad FromStatus data")
      ENDIF
      this.SetValue (left (status, slen))
      status = substr (status, slen + 2)
   RETURN
ENDCLASS

CLASS HLSVarString (oContainer, cName) OF HLSFixedString (oContainer, cName, 0)
   * a variable length string that will
   * read until \0 and
   * write and fill up with \0
   * inline this with care !
   this.ClassName = "HLSVarString"

   PROCEDURE GetSize
      IF this.IsNull ()
         RETURN 0
      ENDIF
   RETURN (len (this.GetValue ()) + 1) * SIZEOF_VDBCHAR
ENDCLASS

CLASS HLSFieldScalar (oContainer, cName) OF HLSField (oContainer, cName)
   this.ClassName = "HLSFieldScalar"
   this.SetValue (0)

   PROCEDURE ToStatus
   RETURN itoh (this.GetValue ()) + ";"

   PROCEDURE FromStatus (status)
      this.SetValue (val (status))
      status = substr (status, at (";", status) + 1)
   RETURN
ENDCLASS

CLASS HLSFieldUnsignedScalar (oContainer, cName) OF HLSFieldScalar (oContainer, cName)
   this.ClassName = "HLSFieldUnsignedScalar"

   PROCEDURE Put_ (oMem, nOffs)
      oMem.PutUnsigned (nOffs, this.GetValue (), this.GetSize ())
   RETURN

   PROCEDURE Get_ (oMem, nOffs)
      this.SetValue (oMem.GetUnsigned (nOffs, this.GetSize ()))
   RETURN
ENDCLASS

CLASS HLSFieldUInt32 (oContainer, cName) OF HLSFieldUnsignedScalar (oContainer, cName)
   this.ClassName = "HLSFieldUInt32"

   PROCEDURE GetSize
   RETURN 4
ENDCLASS

CLASS HLSFieldUInt16 (oContainer, cName) OF HLSFieldUnsignedScalar (oContainer, cName)
   this.ClassName = "HLSFieldUInt16"

   PROCEDURE GetSize
   RETURN 2
ENDCLASS

CLASS HLSFieldUInt8 (oContainer, cName) OF HLSFieldUnsignedScalar (oContainer, cName)
   this.ClassName = "HLSFieldUInt8"

   PROCEDURE GetSize
   RETURN 1
ENDCLASS

CLASS HLSFieldSignedScalar (oContainer, cName) OF HLSFieldScalar (oContainer, cName)
   PROTECT fudge, nbit
   this.ClassName = "HLSFieldSignedScalar"
   this.fudge = 0
   this.nbit  = 0

   PROCEDURE Put_ (oMem, nOffs)
      oMem.PutUnsigned (nOffs, ;
         iif (this.GetValue () < 0, this.GetValue () + this.fudge, this.GetValue ()), this.GetSize ())
   RETURN

   PROCEDURE Get_ (oMem, nOffs)
      LOCAL n ; n = oMem.GetUnsigned (nOffs, this.GetSize ())
      this.SetValue (iif (bitset (n, this.nBit), n + 0.0 - this.fudge, n + 0.0))
   RETURN
ENDCLASS

CLASS HLSFieldInt32 (oContainer, cName) OF HLSFieldSignedScalar (oContainer, cName)
   this.ClassName = "HLSFieldInt32"
   this.fudge = 4294967296
   this.nbit  = 31

   PROCEDURE GetSize
   RETURN 4
ENDCLASS

CLASS HLSFieldInt16 (oContainer, cName) OF HLSFieldSignedScalar (oContainer, cName)
   this.ClassName = "HLSFieldInt16"
   this.fudge = 65536
   this.nbit  = 15

   PROCEDURE GetSize
   RETURN 2
ENDCLASS

CLASS HLSFieldInt8 (oContainer, cName) OF HLSFieldSignedScalar (oContainer, cName)
   this.ClassName = "HLSFieldInt8"
   this.fudge = 256
   this.nbit  = 7

   PROCEDURE GetSize
   RETURN 1
ENDCLASS

#ifdef __vdb__
CLASS HLSFieldFloat64 (oContainer, cName) OF HLSField (oContainer, cName)
   this.ClassName = "HLSFieldFloat64"

   PROCEDURE GetSize
   RETURN 8

   PROCEDURE Put_ (oMem, nOffs)
      oMem.PutFloat64 (nOffs, this.GetValue ())
   RETURN

   PROCEDURE Get_ (oMem, nOffs)
      this.SetValue (oMem.GetFloat64 (nOffs))
   RETURN

   PROCEDURE ToStatus
   RETURN ltrim (str (this.GetValue ())) + ";"

   PROCEDURE FromStatus (status)
      this.SetValue (val (status))
      status = substr (status, at (";", status) + 1)
   RETURN
ENDCLASS
#endif

************************************************************************
* HLMem
************************************************************************

CLASS HLMem
   this.ClassName = "HLMem"
   this.hGlob = 0
   this.Mem   = 0
   this.size  = 0
   _app.HLStructHLMems = _app.HLStructHLMems + 1

   PROCEDURE Release
      this.free ()
      _app.HLStructHLMems = _app.HLStructHLMems - 1
   RETURN

   PROCEDURE GetAddr
   RETURN this.mem

   PROCEDURE GetSize
   RETURN this.size

   PROCEDURE Malloc (nBytes)
      this.free ()
      this.hGlob = WinAPIGlobalAlloc (GHND, nBytes)
      IF this.hGlob <> 0
         this.lock ()
         this.size = nBytes
         _app.HLStructHLMemMallocs = _app.HLStructHLMemMallocs  + 1
         _app.HLStructHLMemMallocedBytes = _app.HLStructHLMemMallocedBytes + this.size
      ELSE
         _THROW("HLMem : Malloc error")
      ENDIF
   RETURN

   PROCEDURE FromHGlob (hGlob)
      this.free ()
      this.hGlob = hGlob
      this.lock ()
      this.size = WinAPIGlobalSize (hGlob)
      _app.HLStructHLMemMallocs = _app.HLStructHLMemMallocs  + 1
      _app.HLStructHLMemMallocedBytes = _app.HLStructHLMemMallocedBytes + this.size
   RETURN

   PROCEDURE FromPtr (p, nSize)
      this.free ()
      this.Mem = p
      this.size = nSize
      * _app.HLStructHLMemMallocs = _app.HLStructHLMemMallocs  + 1
      * _app.HLStructHLMemMallocedBytes = _app.HLStructHLMemMallocedBytes + this.size
   RETURN

   PROCEDURE FromMem (oMem, srcOffs, nLen)
      this.free ()
      this.Mem  = oMem.mem  + srcOffs
      this.size = oMem.size - srcOffs
      * _app.HLStructHLMemMallocs = _app.HLStructHLMemMallocs  + 1
      * _app.HLStructHLMemMallocedBytes = _app.HLStructHLMemMallocedBytes + this.size
   RETURN

   PROCEDURE UnOwnHGlob
      this.unlock ()
      this.hGlob = 0
      _app.HLStructHLMemMallocs = _app.HLStructHLMemMallocs  - 1
      _app.HLStructHLMemMallocedBytes = _app.HLStructHLMemMallocedBytes - this.size
   RETURN

   PROCEDURE Free
      this.Unlock ()
      IF this.hGlob <> 0
         WinAPIGlobalFree (this.hGlob)
         this.hGlob = 0
         _app.HLStructHLMemMallocs = _app.HLStructHLMemMallocs  - 1
         _app.HLStructHLMemMallocedBytes = _app.HLStructHLMemMallocedBytes - this.size
      ENDIF
      this.size = 0
   RETURN

   PROCEDURE Lock
      IF this.Mem == 0
         IF this.hGlob <> 0
            this.Mem = WinAPIGlobalLock (this.hGlob)
         ENDIF
      ENDIF
   RETURN

   PROCEDURE Unlock
      IF this.Mem <> 0
         IF this.hGlob <> 0
            WinAPIGlobalUnlock (this.hGlob)
         ENDIF
         this.Mem = 0
      ENDIF
   RETURN

   PROCEDURE Clear
      IF this.size <> 0
         #ifdef __vdb__
            _WinAPIZeroMemory (this.Mem, this.size)
         #else
            LOCAL s ; s = replicate (chr (0), this.size)
            _WinAPIMoveMemory_lptr_ptr (this.Mem, s, this.size)
         #endif
      ENDIF
   RETURN

   PROCEDURE PutUnsigned (nOffs, nInt, nSize)
      * Put an integer in the range 0-4294967295
      * works in VdB 5.x and 7.x
      IF nInt > 2147483647
         nInt = nInt - 4294967296.0
      ENDIF
      _WinAPIMoveMemory_lptr_int32 (this.mem + nOffs, int (nInt), nSize)
   RETURN

   PROCEDURE GetUnsigned (nOffs, nSize)
      LOCAL n ; n = 0
      _WinAPIMoveMemory_int32_lptr (n, this.mem + nOffs, nSize)
      * if its negative make it unsigned
      * vdb-bug-around: promote integers to float, or big numbers wont work
   RETURN iif (n + 0.0 < 0.0, n + 4294967296.0, n + 0.0)

   PROCEDURE PutFloat64 (nOffs, nFloat)
      _WinAPIMoveMemory_lptr_float64 (this.mem + nOffs, nFloat + 0.0, 8)
   RETURN

   PROCEDURE GetFloat64 (nOffs)
      LOCAL n ; n = 0.0
      _WinAPIMoveMemory_float64_lptr (n, this.mem + nOffs, 8)
   RETURN n

   PROCEDURE PutByte (nOffs, nByte)
      _WinAPIMoveMemory_lptr_int32 (this.mem + nOffs, int (nByte), 1)
   RETURN

   PROCEDURE GetByte (nOffs)
      LOCAL n ; n = 0
      _WinAPIMoveMemory_int32_lptr (n, this.mem + nOffs, 1)
   RETURN n

   PROCEDURE PutBytes (nOffs, s, nSize)
      _WinAPIMoveMemory_lptr_ptr (this.mem + nOffs, s, min (nSize, len (s) * SIZEOF_VDBCHAR))
   RETURN

   PROCEDURE GetBytes (nOffs, nSize)
      LOCAL s ; s = MEM_ALLOC(nSize)
      _WinAPIMoveMemory_ptr_lptr (s, this.mem + nOffs, nSize)
   RETURN s

   PROCEDURE FromString (s)
      this.Malloc (len (s) * SIZEOF_VDBCHAR)
      _WinAPIMoveMemory_lptr_ptr (this.mem, s, this.size)
   RETURN

   PROCEDURE ToString
      LOCAL s ; s = MEM_ALLOC(this.size)
      _WinAPIMoveMemory_ptr_lptr (s, (this.mem), (this.size))
   RETURN s

   PROCEDURE FromHex (cHex)
      LOCAL len ; len = len (cHex) / 2
      LOCAL w ; w = STR_ALLOC(len)
      LOCAL i
      FOR i = 0 TO len
         SET_BYTE(w, i, htoi (substr (cHex, i + 1, 2)))
      NEXT
      this.FromString (w)
   RETURN

   PROCEDURE ToHex
      LOCAL s ; s = this.ToString ()
      LOCAL cHex ; cHex = ""
      LOCAL len ; len = this.size - 1
      LOCAL i
      FOR i = 0 TO len
         cHex = cHex + itoh (GET_BYTE(s, i), 2)
      NEXT
   RETURN cHex

#ifndef NDEBUG
   PROCEDURE PrintHex (nIndent)
      LOCAL s ; s = MEM_ALLOC(this.size)
      _WinAPIMoveMemory_ptr_lptr (s, (this.mem), (this.size))
      LOCAL cHex ; cHex = ""
      LOCAL len ; len = this.size - 1
      LOCAL i, c
      ? itoh (this.hGlob, 8) + " : " + itoh (this.mem, 8) + " : " at nIndent
      ?? "-"                                                      at nIndent + 45
      FOR i = 0 TO len
         c = GET_BYTE(s, i)
         ?? itoh (c, 2)                                           at nIndent + 22 + mod (i, 16) * 3
         ?? iif (c > 31, chr (c), ".")                            at nIndent + 71 + mod (i, 16)
         IF mod (i, 16) = 15 .and. i <> len
            ?
            ?? "-"                                                at nIndent + 45
         ENDIF
      NEXT
   RETURN
#endif
ENDCLASS

************************************************************************
* Other
************************************************************************

PROCEDURE RGB (r, g, b)
RETURN r + bitlshift (g, 8) + bitlshift (b, 16)

PROCEDURE Tokenize (cString, cSeparator)
   local a, nIndex, nAT
   a = new ARRAY ()
   nIndex = 1
   do while .t.
      nAT = at (cSeparator, cString)
      if nAT == 0
         nAT = len (cString) + 1
         if nAT == 1
            exit
         endif
      endif
      a.grow (1)
      a [nIndex] = left (cString, nAT - 1)
      nIndex = nIndex + 1
      cString = substr (cString, nAT + 1)
   enddo
RETURN a

************************************************************************
* HLFile class
************************************************************************

#ifdef __vdb__

#define GENERIC_READ                   0x80000000
#define GENERIC_WRITE                  0x40000000
#define GENERIC_EXECUTE                0x20000000
#define GENERIC_ALL                    0x10000000

#define FILE_SHARE_READ                0x00000001
#define FILE_SHARE_WRITE               0x00000002
#define FILE_SHARE_DELETE              0x00000004
#define FILE_ATTRIBUTE_READONLY        0x00000001
#define FILE_ATTRIBUTE_HIDDEN          0x00000002
#define FILE_ATTRIBUTE_SYSTEM          0x00000004
#define FILE_ATTRIBUTE_DIRECTORY       0x00000010
#define FILE_ATTRIBUTE_ARCHIVE         0x00000020
#define FILE_ATTRIBUTE_NORMAL          0x00000080
#define FILE_ATTRIBUTE_TEMPORARY       0x00000100
#define FILE_ATTRIBUTE_COMPRESSED      0x00000800
#define FILE_ATTRIBUTE_OFFLINE         0x00001000
#define INVALID_HANDLE_VALUE           -1
#define INVALID_FILE_SIZE              0xFFFFFFFF

#define FILE_BEGIN                     0
#define FILE_CURRENT                   1
#define FILE_END                       2

#define FILE_FLAG_WRITE_THROUGH        0x80000000
#define FILE_FLAG_OVERLAPPED           0x40000000
#define FILE_FLAG_NO_BUFFERING         0x20000000
#define FILE_FLAG_RANDOM_ACCESS        0x10000000
#define FILE_FLAG_SEQUENTIAL_SCAN      0x08000000
#define FILE_FLAG_DELETE_ON_CLOSE      0x04000000
#define FILE_FLAG_BACKUP_SEMANTICS     0x02000000
#define FILE_FLAG_POSIX_SEMANTICS      0x01000000

#define CREATE_NEW                     1
#define CREATE_ALWAYS                  2
#define OPEN_EXISTING                  3
#define OPEN_ALWAYS                    4
#define TRUNCATE_EXISTING              5

CLASS HLFile
   this.ClassName = "HLFile"
   this.hFile = 0

   PROCEDURE fopen (cFileName, cMode)
      IF this.hFile <> 0
         this.fclose ()
      ENDIF
      LOCAL nMode, nShare, nCreation, nAttributes
      nMode = 0
      IF at ("R", upper (cMode)) > -1
         nMode += GENERIC_READ
      ENDIF
      IF at ("W", upper (cMode)) > -1
         nMode += GENERIC_WRITE
      ENDIF
      nShare = FILE_SHARE_READ
      IF nMode == GENERIC_READ
         nCreation = OPEN_EXISTING
      ENDIF
      IF nMode == GENERIC_WRITE
         nCreation = CREATE_ALWAYS
      ENDIF
      IF nMode == GENERIC_READ + GENERIC_WRITE
         nCreation = OPEN_ALWAYS
      ENDIF
      nAttributes = FILE_ATTRIBUTE_NORMAL

      this.hFile = WinAPICreateFile (cFileName, nMode, nShare, NULL, nCreation, nAttributes, 0)
   RETURN this.hFile <> INVALID_HANDLE_VALUE

   PROCEDURE fclose
      IF this.hFile <> 0
         WinAPICloseHandle (this.hFile)
      ENDIF
      this.hFile = 0
   RETURN

   PROCEDURE fread (oMem, nBytes)
      oMem.malloc (nBytes)
      LOCAL nBytesRead ; nBytesRead = 0
      WinAPIReadFile (this.hFile, oMem.GetAddr (), nBytes, nBytesRead, 0)
      oMem.size = nBytesRead
   RETURN nBytesRead == nBytes

   PROCEDURE fwrite (oMem, nBytes)
      LOCAL nBytesWritten ; nBytesWritten = 0
      WinAPIWriteFile (this.hFile, oMem.GetAddr (), min (nBytes, oMem.size), nBytesWritten, 0)
   RETURN nBytesWritten == nBytes

   PROCEDURE fseek (nOffs, nMode)
      WinAPISetFilePointer (this.hFile, nOffs, NULL, nMode)
   RETURN

   PROCEDURE ftell
   RETURN WinAPISetFilePointer (this.hFile, 0, NULL, FILE_CURRENT)

   PROCEDURE Ok
   RETURN this.hFile <> INVALID_HANDLE_VALUE
ENDCLASS

#else

#define READ         0
#define WRITE        1
#define READ_WRITE   2

#define SEEK_SET     0
#define SEEK_CUR     1
#define SEEK_END     2

#define OF_SHARE_COMPAT     htoi ("0000")
#define OF_SHARE_EXCLUSIVE  htoi ("0010")
#define OF_SHARE_DENY_WRITE htoi ("0020")
#define OF_SHARE_DENY_READ  htoi ("0030")
#define OF_SHARE_DENY_NONE  htoi ("0040")

#define HFILE_ERROR         -1

CLASS HLFile
   this.ClassName = "HLSFile"
   this.hFile = HFILE_ERROR

   PROCEDURE fopen (cFileName, cMode)
      IF this.ok ()
         this.fclose ()
      ENDIF
      LOCAL lRead, lWrite, nMode
      lRead  = at ("R", upper (cMode)) <> 0
      lWrite = at ("W", upper (cMode)) <> 0
      IF lRead
         nMode = READ + OF_SHARE_DENY_NONE
      ENDIF
      IF lWrite
         nMode = WRITE + OF_SHARE_DENY_WRITE
      ENDIF
      IF lRead .and. lWrite
         nMode = READ_WRITE + OF_SHARE_DENY_WRITE
      ENDIF
      this.hFile = WinAPI_lopen (cFileName, nMode)
   RETURN this.ok ()

   PROCEDURE fclose
      IF this.ok ()
         WinAPI_lclose (this.hFile)
         this.hFile = HFILE_ERROR
      ENDIF
   RETURN

   PROCEDURE fread (oMem, nBytes)
      IF .not. this.ok ()
         RETURN .f.
      ENDIF
      oMem.malloc (nBytes)
      LOCAL nBytesRead
      nBytesRead = WinAPI_hread (this.hFile, oMem.GetAddr (), nBytes)
      oMem.size = nBytesRead
   RETURN nBytesRead == nBytes

   PROCEDURE fwrite (oMem, nBytes)
      IF .not. this.ok ()
         RETURN .f.
      ENDIF
      LOCAL nBytesWritten
      nBytesWritten = WinAPI_hwrite (this.hFile, oMem.GetAddr (), min (nBytes, oMem.size))
   RETURN nBytesWritten == nBytes

   PROCEDURE fseek (nOffs, nMode)
      IF .not. this.ok ()
         RETURN
      ENDIF
      _llseek (this.hFile, nOffs, nMode)
   RETURN

   PROCEDURE ftell
      IF .not. this.ok ()
         RETURN -1
      ENDIF
   RETURN _llseek (this.hFile, 0, SEEK_CUR)

   PROCEDURE Ok
   RETURN this.hFile <> HFILE_ERROR
ENDCLASS

#endif
