***************************************************************************
*  Copyright (C) 1998 Marcello Perathoner. All rights reserved.           *
*  email: JLSeagull@csi.com                                               *
*  http://ourworld.compuserve.com/Homepages/JLSeagull/vdb/index.html      *
***************************************************************************

   set procedure to program (1) additive
   InitHLWinAPI ()
RETURN

#include "hlwinapi.cch"
#include "hlstruct.cch"

#define HWND HWINDOW
#define INT CINT

PROCEDURE InitHLWinAPI
   IF type ("WinAPIGlobalAlloc") == "FP"
      RETURN
   ENDIF

************************************************************************
************************************************************************
************************************************************************
***** for 16 and 32 bit
************************************************************************
************************************************************************
************************************************************************

************************************************************************
* KERNEL
************************************************************************

extern HGLOBAL WinAPIGlobalAlloc         (UINT, DWORD)                     KERNEL from "GlobalAlloc"
extern HGLOBAL WinAPIGlobalFree          (HGLOBAL)                         KERNEL from "GlobalFree"
extern LONG    WinAPIGlobalLock          (HGLOBAL)                         KERNEL from "GlobalLock"
extern LONG    WinAPIGlobalSize          (HGLOBAL)                         KERNEL from "GlobalSize"
extern BOOL    WinAPIGlobalUnlock        (HGLOBAL)                         KERNEL from "GlobalUnlock"

extern INT     WinAPIGetPrivateProfileString    (LPCTSTR, LPCTSTR, LPCTSTR, LPTSTR, UINT, LPCTSTR) KERNEL from "GetPrivateProfileString" U
extern INT     WinAPIGetProfileString           (LPCTSTR, LPCTSTR, LPCTSTR, LPTSTR, UINT)          KERNEL from "GetProfileString" U
extern BOOL    WinAPIWritePrivateProfileString  (LPCTSTR, LPCTSTR, LPCTSTR, LPCTSTR)               KERNEL from "WritePrivateProfileString" U

************************************************************************
* USER
************************************************************************

extern HWND    WinAPIGetFocus            ()                                USER  from "GetFocus"
extern HWND    WinAPIGetParent           (HWND)                            USER  from "GetParent"
extern BOOL    WinAPIIsWindow            (HWND)                            USER  from "IsWindow"
extern HWND    WinAPISetFocus            (HWND)                            USER  from "SetFocus"
extern LRESULT WinAPISendMessage         (HWND, UINT, WPARAM, LPARAM)      USER  from "SendMessage" U

************************************************************************
* GDI
************************************************************************

************************************************************************
************************************************************************
************************************************************************
***** for 16 bit only (not yet ported)
************************************************************************
************************************************************************
************************************************************************

#ifndef __vdb__

************************************************************************
* USER
************************************************************************

extern CHANDLE  WinAPIBeginPaint          (CHANDLE, CPTR)                  USER  from "BeginPaint"
extern CHANDLE  WinAPIChildWindowFromPoint  (CHANDLE, CLONG)               USER  from "ChildWindowFromPoint"
extern CVOID    WinAPIClientToScreen      (CHANDLE, CPTR)                  USER  from "ClientToScreen"
extern CHANDLE  WinAPICreateWindow        (CSTRING, CSTRING, CLONG, CINT, CINT, CINT, CINT, CHANDLE, CHANDLE, CHANDLE, CPTR) USER from "CreateWindow"
extern CLONG    WinAPIDispatchMessage     (CPTR)                           USER  from "DispatchMessage"
extern void     WinAPIDrawMenuBar         (HWND)                           USER  from "DrawMenuBar"
extern CINT     WinAPIDrawText            (CHANDLE, CSTRING, CINT, CPTR, CWORD) USER from "DrawText"
extern CLOGICAL WinAPIDragDetect          (CHANDLE, CPTR)                  USER  from "DragDetect" && undoc
extern CINT     WinAPIEnableMenuItem      (CHANDLE, CWORD, CWORD)          USER  from "EnableMenuItem"
extern CVOID    WinAPIEndPaint            (CHANDLE, CPTR)                  USER  from "EndPaint"
extern CINT     WinAPIFillRect            (CHANDLE, CPTR, CHANDLE)         USER  from "FillRect"
extern CHANDLE  WinAPIGetCapture          ()                               USER  from "GetCapture"
extern CLONG    WinAPIGetClassLong        (CHANDLE, CINT)                  USER  from "GetClassLong"
extern CINT     WinAPIGetClassName        (CHANDLE, CPTR, CINT)            USER  from "GetClassName"
extern CWORD    WinAPIGetClassWord        (CHANDLE, CINT)                  USER  from "GetClassWord"
extern CVOID    WinAPIGetClientRect       (CHANDLE, CPTR)                  USER  from "GetClientRect"
extern CVOID    WinAPIGetCursorPos        (CPTR)                           USER  from "GetCursorPos"
extern CHANDLE  WinAPIGetDC               (CHANDLE)                        USER  from "GetDC"
extern CHANDLE  WinAPIGetDesktopWindow    ()                               USER  from "GetDesktopWindow"
extern CINT     WinAPIGetKeyState         (CINT)                           USER  from "GetKeyState"
extern HMENU    WinAPIGetMenu             (HWND)                           USER  from "GetMenu"
extern int      WinAPIGetMenuItemCount    (HMENU)                          USER  from "GetMenuItemCount"
extern UINT     WinAPIGetMenuItemId       (HMENU, int)                     USER  from "GetMenuItemId"
extern int      WinAPIGetMenuString       (HMENU, UINT, LPSTR, int, UINT)  USER  from "GetMenuString"
extern CLOGICAL WinAPIGetMessage          (CPTR, CHANDLE, CWORD, CWORD)    USER  from "GetMessage"
extern CINT     WinAPIGetSystemMetrics    (CINT)                           USER  from "GetSystemMetrics"
extern CLONG    WinAPIGetTickCount        ()                               USER  from "GetTickCount"
extern CLONG    WinAPIGetTimerResolution  ()                               USER  from "GetTimerResolution"
extern CHANDLE  WinAPIGetWindow           (CHANDLE, CWORD)                 USER  from "GetWindow"
extern CHANDLE  WinAPIGetWindowDC         (CHANDLE)                        USER  from "GetWindowDC"
extern CLONG    WinAPIGetWindowLong       (CHANDLE, CINT)                  USER  from "GetWindowLong"
extern CVOID    WinAPIGetWindowRect       (CHANDLE, CPTR)                  USER  from "GetWindowRect"
extern CINT     WinAPIGetWindowText       (CHANDLE, CPTR, CINT)            USER  from "GetWindowText"
extern CWORD    WinAPIGetWindowWord       (CHANDLE, CINT)                  USER  from "GetWindowWord"
extern CVOID    WinAPIHideCaret           (CHANDLE)                        USER  from "HideCaret"
extern CVOID    WinAPIInvalidateRect      (CHANDLE, CLONG, CLOGICAL)       USER  from "InvalidateRect"
extern HBITMAP  WinAPILoadBitmap          (HINSTANCE, CPTR)                USER  from "LoadBitmap"
extern CLOGICAL WinAPILockWindowUpdate    (CHANDLE)                        USER  from "LockWindowUpdate"
extern bool     WinAPIModifyMenu          (HMENU, UINT, UINT, UINT, CPTR)  USER from "ModifyMenu"
extern CLOGICAL WinAPIPeekMessage         (CPTR, CHANDLE, CWORD, CWORD, CWORD) USER from "PeekMessage"
extern CLONG    WinAPIPostMessage         (CHANDLE, CWORD, CWORD, CLONG)   USER  from "PostMessage"
extern CLONG    WinAPIPostMessagePtr      (CHANDLE, CWORD, CWORD, CPTR)    USER  from "PostMessage"
extern CVOID    WinAPIPostQuitMessage     (CINT)                           USER  from "PostQuitMessage"
extern CLOGICAL WinAPIPtInRect            (CPTR, CLONG)                    USER  from "PtInRect"
extern CWORD    WinAPIRealizePalette      (CHANDLE)                        USER  from "RealizePalette"
extern CVOID    WinAPIReleaseCapture      ()                               USER  from "ReleaseCapture"
extern CINT     WinAPIReleaseDC           (CHANDLE, CHANDLE)               USER  from "ReleaseDC"
extern CVOID    WinAPIScreenToClient      (CHANDLE, CPTR)                  USER  from "ScreenToClient"
extern CHANDLE  WinAPISelectPalette       (CHANDLE, CHANDLE, CLOGICAL)     USER  from "SelectPalette"
extern CVOID    WinAPISetRect             (CPTR, CINT, CINT, CINT, CINT)   USER  from "SetRect"
extern CLONG    WinAPISendDlgItemMessage  (CHANDLE, CINT, CINT, CWORD, CLONG) USER from "SendDlgItemMessage"
extern CLONG    WinAPISendMessagePtr      (CHANDLE, CWORD, CWORD, CPTR)    USER  from "SendMessage"
extern CHANDLE  WinAPISetCapture          (CHANDLE)                        USER  from "SetCapture"
extern CWORD    WinAPISetClassWord        (CHANDLE, CINT, CWORD)           USER  from "GetClassWord"
extern CHANDLE  WinAPISetParent           (CHANDLE, CHANDLE)               USER  from "SetParent"
extern CLONG    WinAPISetWindowLong       (CHANDLE, CINT, CLONG)           USER  from "SetWindowLong"
extern CLOGICAL WinAPISetWindowPos        (CHANDLE, CHANDLE, CINT, CINT, CINT, CINT, CWORD) USER  from "SetWindowPos"
extern CWORD    WinAPISetWindowWord       (CHANDLE, CINT, CWORD)           USER  from "SetWindowWord"
extern CVOID    WinAPIShowCaret           (CHANDLE)                        USER  from "ShowCaret"
extern CLOGICAL WinAPITranslateMessage    (CPTR)                           USER  from "TranslateMessage"
extern CVOID    WinAPIUpdateWindow        (CHANDLE)                        USER  from "UpdateWindow"
extern CVOID    WinAPIValidateRect        (CHANDLE, CLONG)                 USER  from "ValidateRect"
extern CHANDLE  WinAPIWindowFromPoint     (CLONG)                          USER  from "WindowFromPoint"

extern CINT     WinAPIOpenComm            (CSTRING, CWORD, CWORD)          USER from "OpenComm"
extern CINT     WinAPICloseComm           (CINT)                           USER from "CloseComm"
extern CINT     WinAPIBuildCommDCB        (CSTRING, CPTR)                  USER from "BuildCommDCB"
extern CINT     WinAPISetCommState        (CPTR)                           USER from "SetCommState"
extern CINT     WinAPIWriteComm           (CINT, CPTR, CINT)               USER from "WriteComm"
extern CINT     WinAPIReadComm            (CINT, CPTR, CINT)               USER from "ReadComm"
extern CLOGICAL WinAPIEnableCommNotification  (CINT, CHANDLE, CINT, CINT)  USER from "EnableCommNotification"

************************************************************************
* KERNEL
************************************************************************

extern CHANDLE  WinAPIFindResource_LL     (CHANDLE, CLONG, CLONG)          KERNEL from "FindResource"
extern CVOID    WinAPIFreeLibrary         (CHANDLE)                        KERNEL from "FreeLibrary"
extern CLOGICAL WinAPIFreeResource        (CHANDLE)                        KERNEL from "FreeResource"
extern CINT     WinAPIGetModuleFileName   (HINSTANCE, LPSTR, CINT)         KERNEL from "GetModuleFilename"
extern HMODULE  WinAPIGetModuleHandle     (LPCSTR)                         KERNEL from "GetModuleHandle"
extern CINT     WinAPIGetModuleUsage      (CHANDLE)                        KERNEL from "GetModuleUsage"

extern CHANDLE  WinAPILoadLibrary         (CSTRING)                        KERNEL from "LoadLibrary"
extern CHANDLE  WinAPILoadResource        (CHANDLE, CHANDLE)               KERNEL from "LoadResource"
extern CLONG    WinAPILockResource        (CHANDLE)                        KERNEL from "LockResource"
extern CLONG    WinAPI_hread              (CHANDLE, CPTR, CLONG)           KERNEL from "_hread"
extern CLONG    WinAPI_hread_l            (CHANDLE, CLONG, CLONG)          KERNEL from "_hread"
extern CLONG    WinAPI_hwrite             (CHANDLE, CPTR, CLONG)           KERNEL from "_hwrite"
extern CHANDLE  WinAPI_lclose             (CHANDLE)                        KERNEL from "_lclose"
extern CLONG    WinAPI_llseek             (CHANDLE, CLONG, CINT)           KERNEL from "_llseek"
extern CHANDLE  WinAPI_lopen              (CSTRING, CINT)                  KERNEL from "_lopen"

************************************************************************
* GDI
************************************************************************

extern CINT     WinAPIAbortDoc            (CHANDLE)                        GDI   from "AbortDoc"
extern CLOGICAL WinAPIBitBlt              (CHANDLE, CINT, CINT, CINT, CINT, CHANDLE, CINT, CINT, CLONG) GDI from "BitBlt"
extern CHANDLE  WinAPICreateBitmap        (CINT, CINT, CWORD, CWORD, CPTR) GDI   from "CreateBitmap"
extern CHANDLE  WinAPICreateBrushIndirect (CPTR)                           GDI   from "CreateBrushIndirect"
extern CHANDLE  WinAPICreateCompatibleBitmap (CHANDLE, CINT, CINT)         GDI   from "CreateCompatibleBitmap"
extern CHANDLE  WinAPICreateCompatibleDC     (CHANDLE)                     GDI   from "CreateCompatibleDC"
extern CHANDLE  WinAPICreateDC            (CSTRING, CSTRING, CSTRING, CPTR)   GDI from "CreateDC"
extern CHANDLE  WinAPICreateDC_SSSL       (CSTRING, CSTRING, CSTRING, CLONG)  GDI from "CreateDC"
extern CHANDLE  WinAPICreateDIBitmap      (CHANDLE, CLONG, CLONG, CLONG, CLONG, CWORD) GDI from "CreateDIBitmap"
extern CHANDLE  WinAPICreateFont          (CINT, CINT, CINT, CINT, CINT, CLOGICAL, CLOGICAL, CLOGICAL, CINT, CINT, CINT, CINT, CINT, CSTRING) GDI from "CreateFont"
extern CHANDLE  WinAPICreateIC            (CSTRING, CSTRING, CSTRING, CPTR)   GDI from "CreateIC"
extern CHANDLE  WinAPICreatePalette       (CPTR)                           GDI   from "CreatePalette"
extern CHANDLE  WinAPICreatePen           (CINT, CINT, CLONG)              GDI   from "CreatePen"
extern CHANDLE  WinAPICreateRectRgn       (CINT, CINT, CINT, CINT)         GDI   from "CreateRectRgn"
extern CHANDLE  WinAPICreateSolidBrush    (CLONG)                          GDI   from "CreateSolidBrush"
extern CLOGICAL WinAPIDPtoLP              (CHANDLE, CPTR, CINT)            GDI   from "DPtoLP"
extern CLOGICAL WinAPIDeleteDC            (CHANDLE)                        GDI   from "DeleteDC"
extern CLOGICAL WinAPIDeleteObject        (CHANDLE)                        GDI   from "DeleteObject"
extern CLOGICAL WinAPIEllipse             (CHANDLE, CINT, CINT, CINT, CINT)   GDI from "Ellipse"
extern CINT     WinAPIEndDoc              (CHANDLE)                        GDI   from "EndDoc"
extern CINT     WinAPIEndPage             (CHANDLE)                        GDI   from "EndPage"
extern CINT     WinAPIEscape              (CHANDLE, CINT, CINT, CPTR, CPTR)   GDI from "Escape"
extern CINT     WinAPIGetDeviceCaps       (CHANDLE, CINT)                  GDI   from "GetDeviceCaps"
extern CINT     WinAPIGetMapMode          (CHANDLE)                        GDI   from "GetMapMode"
extern CHANDLE  WinAPIGetStockObject      (CINT)                           GDI   from "GetStockObject"
extern CLONG    WinAPIGetTextExtent       (CHANDLE, CSTRING, CINT)         GDI   from "GetTextExtent"
extern CLOGICAL WinAPIGetTextMetrics      (CHANDLE, CPTR)                  GDI   from "GetTextMetrics"
extern CLONG    WinAPIGetViewportExt      (CHANDLE)                        GDI   from "GetViewportExt"
extern CLONG    WinAPIGetViewportOrg      (CHANDLE)                        GDI   from "GetViewportOrg"
extern CLONG    WinAPIGetWindowExt        (CHANDLE)                        GDI   from "GetWindowExt"
extern CLONG    WinAPIGetWindowOrg        (CHANDLE)                        GDI   from "GetWindowOrg"
extern CLOGICAL WinAPILPtoDP              (CHANDLE, CPTR, CINT)            GDI   from "LPtoDP"
extern CLOGICAL WinAPILineTo              (CHANDLE, CINT, CINT)            GDI   from "LineTo"
extern CLONG    WinAPIMoveTo              (CHANDLE, CINT, CINT)            GDI   from "MoveTo"
extern CLOGICAL WinAPIPatBlt              (CHANDLE, CINT, CINT, CINT, CINT, CLONG) GDI from "PatBlt"
extern CLOGICAL WinAPIRectangle           (CHANDLE, CINT, CINT, CINT, CINT)        GDI from "Rectangle"
extern HDC      WinAPIResetDC             (HDC, CPTR)                      GDI   from "ResetDC"
extern bool     WinAPIRestoreDC           (HDC, CINT)                      GDI   from "RestoreDC"
extern CINT     WinAPISaveDC              (HDC)                            GDI   from "SaveDC"
extern CHANDLE  WinAPISelectObject        (CHANDLE, CHANDLE)               GDI   from "SelectObject"
extern CINT     WinAPISelectClipRgn       (CHANDLE, CHANDLE)               GDI   from "SelectClipRgn"
extern CINT     WinAPISetBkMode           (CHANDLE, CINT)                  GDI   from "SetBkMode"
extern CINT     WinAPISetDIBitsToDevice   (CHANDLE, CINT, CINT, CINT, CINT, CINT, CINT, CWORD, CWORD, CLONG, CLONG, CWORD) GDI from "SetDIBitsToDevice"
extern CINT     WinAPISetMapMode          (CHANDLE, CINT)                  GDI   from "SetMapMode"
extern CINT     WinAPISetMapMode          (CHANDLE, CINT)                  GDI   from "SetMapMode"
extern CWORD    WinAPISetTextAlign        (CHANDLE, CWORD)                 GDI   from "SetTextAlign"
extern CLONG    WinAPISetTextColor        (CHANDLE, CLONG)                 GDI   from "SetTextColor"
extern CLONG    WinAPISetViewportExt      (CHANDLE, CINT, CINT)            GDI   from "SetViewportExt"
extern CLONG    WinAPISetViewportOrg      (CHANDLE, CINT, CINT)            GDI   from "SetViewportOrg"
extern CLONG    WinAPISetWindowExt        (CHANDLE, CINT, CINT)            GDI   from "SetWindowExt"
extern CLONG    WinAPISetWindowOrg        (CHANDLE, CINT, CINT)            GDI   from "SetWindowOrg"
extern CINT     WinAPIStartDoc            (CHANDLE, CPTR)                  GDI   from "StartDoc"
extern CINT     WinAPIStartPage           (CHANDLE)                        GDI   from "StartPage"
extern CLOGICAL WinAPIStretchBlt          (CHANDLE, CINT, CINT, CINT, CINT, CHANDLE, CINT, CINT, CINT, CINT, CLONG) GDI from "StretchBlt"
extern CINT     WinAPIStretchDIBits       (CHANDLE, CINT, CINT, CINT, CINT, CINT, CINT, CINT, CINT, CLONG, CLONG, CWORD, CLONG) GDI from "StretchDIBits"
extern CLOGICAL WinAPITextOut             (CHANDLE, CINT, CINT, CSTRING, CINT) GDI from "TextOut"

************************************************************************
* SHELL
************************************************************************

extern CVOID    WinAPIDragAcceptFiles     (CHANDLE, CLOGICAL)              SHELL from "DragAcceptFiles"
extern CVOID    WinAPIDragFinish          (CHANDLE)                        SHELL from "DragFinish"
extern CWORD    WinAPIDragQueryFile       (CHANDLE, CWORD, CPTR, CWORD)    SHELL from "DragQueryFile"
extern CLOGICAL WinAPIDragQueryPoint      (CHANDLE, CPTR)                  SHELL from "DragQueryPoint"

#endif

RETURN

CLASS HLS_POINT OF HLStruct
   HLS_INT("x")
   HLS_INT("y")
ENDCLASS

CLASS HLS_POINTS OF HLStruct
   HLS_SHORT("x")
   HLS_SHORT("y")
ENDCLASS

CLASS HLS_POINTL OF HLStruct
   HLS_LONG("x")
   HLS_LONG("y")
ENDCLASS

CLASS HLS_SIZE OF HLStruct
    HLS_INT("cx")
    HLS_INT("cy")
ENDCLASS

CLASS HLS_RECT OF HLStruct
   HLS_INT("left")
   HLS_INT("top")
   HLS_INT("right")
   HLS_INT("bottom")
ENDCLASS

CLASS HLS_NEWTEXTMETRIC OF HLStruct
   * TEXTMETRIC fields
    HLS_INT("tmHeight")
    HLS_INT("tmAscent")
    HLS_INT("tmDescent")
    HLS_INT("tmInternalLeading")
    HLS_INT("tmExternalLeading")
    HLS_INT("tmAveCharWidth")
    HLS_INT("tmMaxCharWidth")
    HLS_INT("tmWeight")
    HLS_BYTE("tmItalic")
    HLS_BYTE("tmUnderlined")
    HLS_BYTE("tmStruckOut")
    HLS_BYTE("tmFirstChar")
    HLS_BYTE("tmLastChar")
    HLS_BYTE("tmDefaultChar")
    HLS_BYTE("tmBreakChar")
    HLS_BYTE("tmPitchAndFamily")
    HLS_BYTE("tmCharSet")
    HLS_INT("tmOverhang")
    HLS_INT("tmDigitizedAspectX")
    HLS_INT("tmDigitizedAspectY")
    * NEWTEXTMETRIC fields
    HLS_DWORD("ntmFlags")
    HLS_UINT("ntmSizeEM")
    HLS_UINT("ntmCellHeight")
    HLS_UINT("ntmAvgWidth")
ENDCLASS

CLASS HLS_DOCINFO OF HLStruct
    HLS_INT("cbSize")
    HLS_LPCSTR("lpszDocName")
    HLS_LPCSTR("lpszOutput")
#if (WINVER >= htoi ("0400"))
    HLS_LPCTSTR("lpszDatatype")
    HLS_DWORD("fwType")
#endif
    this.cbSize = this.GetSize ()
ENDCLASS

CLASS HLS_LOGFONT OF HLStruct
   HLS_INT("lfHeight")
   HLS_INT("lfWidth")
   HLS_INT("lfEscapement")
   HLS_INT("lfOrientation")
   HLS_INT("lfWeight")
   HLS_BYTE("lfItalic")
   HLS_BYTE("lfUnderline")
   HLS_BYTE("lfStrikeOut")
   HLS_BYTE("lfCharSet")
   HLS_BYTE("lfOutPrecision")
   HLS_BYTE("lfClipPrecision")
   HLS_BYTE("lfQuality")
   HLS_BYTE("lfPitchAndFamily")
   HLS_TCHARS("lfFaceName", LF_FACESIZE)
ENDCLASS

CLASS HLS_LOGBRUSH OF HLStruct
    HLS_UINT("lbStyle")
    HLS_DWORD("lbColor")
    HLS_INT("lbHatch")
ENDCLASS

CLASS HLS_LOGPEN OF HLStruct
    HLS_UINT("lopnStyle")
    HLS_INLINEDSTRUCT("lopnWidth", new HLS_POINT ())
    HLS_DWORD("lopnColor")
ENDCLASS

CLASS HLS_MSG OF HLStruct
    HLS_HWND("hwnd")
    HLS_UINT("message")
    HLS_WPARAM("wParam")
    HLS_LPARAM("lParam")
    HLS_DWORD("time")
    HLS_INLINEDSTRUCT("pt", new HLS_POINT ())
ENDCLASS

CLASS HLS_PAINTSTRUCT OF HLStruct
   HLS_HDC("hdc")
   HLS_BOOL("fErase")
   HLS_INLINEDSTRUCT("rcPaint", new HLS_RECT ())
   HLS_BOOL("fRestore")
   HLS_BOOL("fIncUpdate")
   HLS_BYTES("rgbReserved", 16)
ENDCLASS

CLASS HLS_WINDOWPLACEMENT OF HLStruct
    HLS_UINT("length")
    HLS_UINT("flags")
    HLS_UINT("showCmd")
    HLS_INLINEDSTRUCT("ptMinPosition", new HLS_POINT ())
    HLS_INLINEDSTRUCT("ptMaxPosition", new HLS_POINT ())
    HLS_INLINEDSTRUCT("rcNormalPosition", new HLS_RECT ())
ENDCLASS
