/* FindWin.PRG: Find a top-level window by its title text
   Useful for detecting when an app is already running.
   Does NOT search child windows
*/

Procedure FindWin
   parameter cTitleText
   if type("cTitleText") # "C"
      return 0
   endif
   if type("FindWindow") # "FP"
      extern cHandle FindWindow(CSTRING, CSTRING) User32 ;
             from "FindWindowA"
   endif
return FindWindow(0, cTitleText)

