// ShowWin.PRG: Set the display state of a running Window
Procedure ShowWin
   parameter nHWND, nHow
   /* Values for nHow:
      0 - Hide completely from view 
      1 - Normal window
      2 - Minimize
      3 - Maximize
   */ 
   if type("nHWND") # "N"
      return
   else
      if nHWND == 0
         return
      endif
   endif
   if type("nHow") # "N"
      nHow = 1 // default to normal
   endif
   if type("ShowWindow") # "FP"
      extern cHandle ShowWindow(cHandle, cInt) User32
   endif
   ShowWindow(nHWND, nHow)
return

