// STRUCTDEMO.PRG: Demonstrate essentials of STRUCTURE.PRG
// Uses GetClientRect() to retrieve _App.FrameWin client size

#include <structapi.h>  // type definitions

set procedure to _dbwinhome+"samples\structure" additive

if type("GetClientRect") # "FP"
   extern CLOGICAL GetClientRect( CHANDLE, CPTR ) USER32
endif

clear
sBuff = new ClientRect_Struct()  // Create and instance of the stucture

GetClientRect(_app.framewin.hwnd,sBuff.value) // call the API function

? "Size of Visual dBASE Client Rectangle"
? "-------------------------------------"
? "Height:", sBuff.getmember("Bottom")
? "Width: ", sBuff.getmember("Right")


CLASS ClientRect_Struct of structure   // structure definition per  
                                       // Win32API.h
   super::addMember( TYPE_DWORD, "Top")
   super::addMember( TYPE_DWORD, "Left")
   super::addMember( TYPE_DWORD, "Bottom")
   super::addMember( TYPE_DWORD, "Right")
endclass
