/* ThisEXE: Returns the name of the currently running EXE.  
            Handy in case where users have been playing around!  
  
    This function converts the buffer returned from GetModuleFileName
    to a standard dBASE Unicode string.  
    
    Most all of this code comes from Jim Sare
*/
Function ThisEXE
   LOCAL cBuff, nCount, nHand, cRetVal, i
   if type("GetModuleHandleN1") # "FP"
      extern CHANDLE GetModuleHandle(CLONG) Kernel32;
             From "GetModuleHandleA"
   endif
   if type("GetModuleFileName") # "FP"
      extern CLONG GetModuleFileName(CHANDLE, CPTR, CLONG) Kernel32;
             From "GetModuleFileNameA"
   endif
   cBuff  = space(128) // Actualy 256 bytes!
   nHand  = GetModuleHandleN1(0) // 0 = calling process
   nCount = GetModuleFileName(nHand, cBuff, len(cBuff) * 2)
   cRetVal = ""
   for i = 0 to nCount - 1             // add characters one at a time
      cRetVal += chr(cBuff.GetByte(i)) // except null terminator
   next
return cRetVal

