/* WinSTART.PRG: uses the ShellExecute API call to execute a Windows 
   "start" without dropping to t

   Makes launching any registered app a cinch. E.g., to launch the 
   default browser and point it at my site:

      WinStart("http://www.sckans.edu/~kgc")

   To start an Email to me:

      WinStart("mailto:kgc@hit.net")

   ..and so on.
*/
function WinStart
   parameter cCommand
   if type("cCommand") # "C"
      return
   endif
   if type("ShellExecute") # "FP"
      extern cHandle ShellExecute(cHandle,cstring,cstring,cstring,cstring,CINT) ;
             shell32 from "ShellExecuteA"
   endif

return ShellExecute(0,"open",cCommand,null,null,1)
